-- RaidVoice
-- author : Starouscz
--
-- X-perl integration code is based on XPerl_Voice.lua
-- used with authors permission

local playerName = UnitName("player");
local raidLeaderName = nil;
RaidVoiceSkins = {}
textCurrentVoiceKey = nil;
local speaking=0;
local soundVolume;
local silenced=0;
local RaidVoiceIsShown = -1;
-- raidVoiceSettings_Reset() values;
raidVoiceHidden=0;
raidVoiceLock=0;
raidVoiceClamp=1;
raidVoiceSkin = 3;
raidVoiceSize = 180;
raidVoiceSpecialKeyBinding = 0;
raidVoiceChannelsCount = 5;
raidVoiceChannelsVersion = 0;
RaidVoiceChannels = {
	RAIDVOICE_DEFAULTCHANNEL1,
	RAIDVOICE_DEFAULTCHANNEL2,
	RAIDVOICE_DEFAULTCHANNEL3,
	RAIDVOICE_DEFAULTCHANNEL4,
	RAIDVOICE_DEFAULTCHANNEL5,
};
raidVoiceCurrentChannel=0;
raidVoiceSync = 1;
raidVoiceSilencing = 0;
raidVoiceActivation= 0;



function raidVoiceOnLoad() 

RaidVoiceSkins = {
RAIDVOICE_GREY,
RAIDVOICE_DARK1,
RAIDVOICE_DARK2,
RAIDVOICE_GREEN,
RAIDVOICE_VIOLET,
RAIDVOICE_RED,
RAIDVOICE_BROWN,
RAIDVOICE_TRANSPARENT1,
RAIDVOICE_TRANSPARENT2
}


	BINDING_HEADER_RaidVoice = "Raid Voice";
	InterfaceOptions_AddCategory(RaidVoice_Settings);
	showSpeaker(nil); 
 	if ((raidVoiceVersion == nil) or not(raidVoiceVersion ==  GetAddOnMetadata("RaidVoice","Version"))) then
  	--	showSpeaker(RAIDVOICE_ADDONLOADED) breaks sounds silencing
		if (raidVoiceVersion == nil) then 	DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_FIRSTTIME);
			raidVoiceSettings_Reset();
			RaidVoice_Text:SetWidth(raidVoiceSize -60);
		end
			
		raidVoiceVersion = GetAddOnMetadata("RaidVoice","Version");
  	end

	if (RaidVoiceChannels == nil or raidVoiceChannelsVersion == nil or RaidVoiceChannels[1]==nil) then raidVoiceChannels_Reset();end;

	UIDropDownMenu_Initialize(DropDownChannelSelect, ChannelsMenuInit,"MENU" );
	UIDropDownMenu_SetWidth(DropDownChannelSelect, 1);
	UIDropDownMenu_SetSelectedValue(DropDownChannelSelect, raidVoiceCurrentChannel);
	UIDropDownMenu_JustifyText(DropDownChannelSelect, "LEFT");
--	 ToggleDropDownMenu(1, nil, DropDownChannelSelect, self, -20, 0);


	SLASH_RAIDVOICE1, SLASH_RAIDVOICE2 = '/raidvoice', '/rv';
	SlashCmdList["RAIDVOICE"] = function(msg)
		raidVoiceSlashHandler(msg);
	end

	RaidVoice_display:SetClampedToScreen(raidVoiceClamp);
	RaidVoice_Settings_Slider1:SetValue(raidVoiceSize);

 	if raidVoiceLock == 1 then       
		RaidVoice_main:EnableMouse(false);
	end
	
	raidVoiceSetSkin(raidVoiceSkin);
	raidVoiceOnShow();

	if (raidVoiceActivation == 1)then
		local newUpdate =  function() voiceActivation(); end;
		RaidVoice_display:SetScript("OnUpdate", newUpdate);
		
	end
			 	 
	 
end 


function raidVoiceOnShow() 

 if raidVoiceHidden == 0  then VoiceChatDisplayFadeIn();end 
 if raidVoiceHidden == 1  then 	
	if RaidVoice_Text:GetText() == nil or RaidVoiceIsShown == -1 then
	      VoiceChatDisplayFadeOut();
	else
	      VoiceChatDisplayFadeIn();
	end
 end
 if raidVoiceHidden == 2  then 	VoiceChatDisplayFadeOut();end


--if (raidVoiceActivation == 1)then
			--Disable blizz voice frame
		VoiceChatTalkers:UnregisterAllEvents();
		VoiceChatTalkers:SetScript("OnLoad",nil);
		VoiceChatTalkers:SetScript("OnUpdate",nil);
		VoiceChatTalkers:SetScript("OnEnter",nil);
		VoiceChatTalkers:SetScript("OnEvent",nil);
		VoiceChatTalkers:Hide();
		
		raidVoiceHookVoiceChat();
--end

end


function showSpeaker(name) 
	local text = RaidVoice_Text:GetText();
 -- 				RaidVoice_Text:SetTextColor(0, 1.0, 0);
	if not(name == nil) then
		if not (GetCVar("Sound_MasterVolume") == 0) then
			if (silenced == 0) then
				soundVolume = GetCVar("Sound_MasterVolume");
			end;
		end
		if (raidVoiceSilencing == 1 and tonumber(soundVolume) > 0) then SetCVar("Sound_MasterVolume","0"); silenced = 1;end;
		if (text == nil) then
			RaidVoice_Text:SetText(name);
			if (name == raidLeaderName) then
				point, relativeTo, relativePoint, xOfs, yOfs  = RaidVoiceLeaderTexture:GetPoint(1);
				RaidVoiceLeaderTexture:ClearAllPoints();
				RaidVoiceLeaderTexture:SetPoint(point, relativeTo, relativePoint, xOfs, 0);
				RaidVoiceLeaderTexture:Show();
			end
		else
			if not string.find(text, name) then
  				RaidVoice_Text:SetText(name.."\n"..text);
				RaidVoice_main:SetHeight(RaidVoice_main:GetHeight() + 12);
				if (name == raidLeaderName)then
					point, relativeTo, relativePoint, xOfs, yOfs  = RaidVoiceLeaderTexture:GetPoint(1);
					RaidVoiceLeaderTexture:ClearAllPoints();
					RaidVoiceLeaderTexture:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs +6);
					RaidVoiceLeaderTexture:Show();
				else
					point, relativeTo, relativePoint, xOfs, yOfs  = RaidVoiceLeaderTexture:GetPoint(1);
					RaidVoiceLeaderTexture:ClearAllPoints();
					RaidVoiceLeaderTexture:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs -6);

				end
			end
		end
	else
		if (silenced == 1) then
			SetCVar("Sound_MasterVolume",soundVolume);
			silenced=0;
		end
		RaidVoice_Text:SetText(nil);
		RaidVoice_main:SetHeight(30);
		point, relativeTo, relativePoint, xOfs, yOfs  = RaidVoiceLeaderTexture:GetPoint(1);
		RaidVoiceLeaderTexture:ClearAllPoints();
		RaidVoiceLeaderTexture:SetPoint(point, relativeTo, relativePoint, xOfs, 0);
		RaidVoiceLeaderTexture:Hide();
	end

-- show on x perl frames
UpdateAllVoiceOnXperl();

end 


function raidVoiceEventHandler(event, arg1)

      if event == "CHAT_MSG_ADDON" and arg1 == "RAIDVOICE" then
		someoneSpeaking(event, arg1);
	end
      if event == "ADDON_LOADED"  and arg1 == "RaidVoice" then
		raidVoiceOnLoad();
	end
	 if event == "PLAYER_ENTERING_WORLD"  then
			inInstance, instanceType = IsInInstance();
		if ( inInstance and instanceType == "pvp" and raidVoiceCurrentChannel == 0) then raidVoiceCurrentChannel=100;
			else
				if (raidVoiceCurrentChannel == 100) then raidVoiceCurrentChannel=0;end;
    	end;
    	UIDropDownMenu_SetSelectedValue(DropDownChannelSelect, raidVoiceCurrentChannel);
    	
    	Channels_update();
	    Channels_requestUpdate();
  	end

      if event == "MODIFIER_STATE_CHANGED" then
	  if raidVoiceSpecialKeyBinding == 0 then return
	  end
		shiftDown = IsShiftKeyDown();
		ctrlDown  = IsControlKeyDown();
		altDown   = IsAltKeyDown();
	  if (raidVoiceSpecialKeyBinding == 1 ) then
		if shiftDown then raidVoiceKeyDown();
		else
		    raidVoiceKeyUp();
		end
	  end
	  if (raidVoiceSpecialKeyBinding == 3) then
		if ctrlDown then raidVoiceKeyDown();
		else
		    raidVoiceKeyUp();
		end
	  end
	  if (raidVoiceSpecialKeyBinding == 4) then
		if (ctrlDown or shiftDown) then raidVoiceKeyDown();
		else
		    raidVoiceKeyUp();
		end
	  end

	  if (raidVoiceSpecialKeyBinding == 5) then
		if altDown then raidVoiceKeyDown();
		else
		    raidVoiceKeyUp();
		end
	  end

	  if (raidVoiceSpecialKeyBinding == 6) then
		if (altDown or shiftDown) then raidVoiceKeyDown();
		else
		    raidVoiceKeyUp();
		end
	  end

	  if (raidVoiceSpecialKeyBinding == 8) then
		if (altDown or ctrlDown) then raidVoiceKeyDown();
		else
		    raidVoiceKeyUp();
		end
	  end

	  if (raidVoiceSpecialKeyBinding == 9) then
		if (altDown or ctrlDown or shiftDown) then raidVoiceKeyDown();
		else
		    raidVoiceKeyUp();
		end
	  end
		
        end
        
    if event == "RAID_ROSTER_UPDATE"  then
		raidVoiceRaidChanged();
	end
	
end



function someoneSpeaking(event, arg1)

		if string.find(arg2, "!CH(%d*);")   then
			local recievedChannel = tonumber(string.gsub(arg2, "!CH(%d*);(.*)", "%1"),10);
		    if (recievedChannel == raidVoiceCurrentChannel) then
				 arg2 = string.gsub(arg2, "!CH(%d*);(.*)", "%2");
				 someoneSpeaking(event, arg1);
				 return; 
	        end;
	
	  end

      if arg2 == "!PING"  then

		SendAddonMessage( "RAIDVOICE", "!PONG;"..playerName..";"..raidVoiceCurrentChannel..";"..raidVoiceVersion, "WHISPER",arg4 );

      end
      if arg2 == "!GPING"  then
		SendAddonMessage( "RAIDVOICE", "!GPONG;"..playerName..";"..raidVoiceCurrentChannel..";"..raidVoiceVersion, "WHISPER",arg4 );	
      end

      if string.find(arg2, "!") == null then
		 if not (arg2 == playerName) then
		 	if raidVoiceHidden == 1 then 
		 		raidVoiceOnShow();
				--VoiceChatDisplayFadeIn(); test iT!!!
  			end
		RaidVoiceSpeakerOnTexture:Show();
		showSpeaker(arg2);
		end
	else
	      if string.find(arg2, "PONG")   then
			if string.find(arg2, "(.*)PONG;(.*);(.*);(.*)")then
 				arg2 = string.gsub(arg2, "(.*)PONG;(.*);(.*);(.*)", "%2     "..RAIDVOICE_CHANNEL..": %3     "..RAIDVOICE_VERSION.." %4");
				local channelIndex = tonumber(string.gsub(arg2, "(.*)"..RAIDVOICE_CHANNEL..": (%d*)(.*)", "%2"),10);
				if channelIndex == 0 then arg2 = string.gsub(arg2,"(.*)"..RAIDVOICE_CHANNEL..": %d*", "%1 "..RAIDVOICE_CHANNEL..": "..RAIDVOICE_PARTYORRAID) end;
				if channelIndex == 100 then arg2 = string.gsub(arg2,"(.*)"..RAIDVOICE_CHANNEL..": %d*", "%1 "..RAIDVOICE_CHANNEL..": "..RAIDVOICE_BATTLEGROUND);end;
				if (not ( channelIndex == 100 or channelIndex == 0)) then  arg2 = string.gsub(arg2,"(.*)"..RAIDVOICE_CHANNEL..": %d*", "%1 "..RAIDVOICE_CHANNEL..": "..RaidVoiceChannels[channelIndex]) end; 
			    DEFAULT_CHAT_FRAME:AddMessage(arg2);
			    
			else
				DEFAULT_CHAT_FRAME:AddMessage(string.gsub(arg2, "(.*)PONG;(.*)", "%2"));

			end
	      end

      end
	if arg2 == "!CLEAR" or arg2 == "" or arg2 == nil then
	   RaidVoiceSpeakerOnTexture:Hide();
		showSpeaker(nil);
		if raidVoiceHidden == 1 then
			VoiceChatDisplayFadeOut();
		end;
	    if speaking == 1 then raidVoiceKeyDown(); end; 
	end

	if string.find(arg2,"!CHANNELS_R") then
		local recievedVersion =tonumber(string.gsub(arg2, "!CHANNELS_R;(.*)", "%1"),10);
		if (raidVoiceChannelsVersion > recievedVersion) then 
			Channels_update();
		end
	end
	if string.find(arg2,"!CHANNELS_U") then
		local recievedVersion =tonumber(string.gsub(arg2, "!CHANNELS_U;(%d*);(.*)", "%1"),10);
		if ( recievedVersion > raidVoiceChannelsVersion ) then 
			Channels_applyUpdate(arg2);
		end
	end


end

function raidVoiceKeyUp() 
	speaking=0;
	
	if raidVoiceHidden == 1 then 
		VoiceChatDisplayFadeOut();
	end
	
	RaidVoiceSpeakerOnTexture:Hide();
	showSpeaker(nil);
    
    speakToChannel("!CLEAR");

end 

function raidVoiceKeyDown() 
	speaking=1;

	if raidVoiceHidden == 1 then
		
		VoiceChatDisplayFadeIn();
	end

	RaidVoiceSpeakerOnTexture:Show();
	showSpeaker(playerName);
	speakToChannel(playerName);


end 




function voiceActivation()
if VoiceChat_IsRecordingLoopbackSound()==1 then return end;
	VoiceChat_RecordLoopbackSound(2);

	--DEFAULT_CHAT_FRAME:AddMessage(VoiceChat_GetCurrentMicrophoneSignalLevel());
	--DEFAULT_CHAT_FRAME:AddMessage(GetCVar("VoiceActivationSensitivity")*100);
	if VoiceChat_GetCurrentMicrophoneSignalLevel() > GetCVar("VoiceActivationSensitivity")*100 then 
			--DEFAULT_CHAT_FRAME:AddMessage("voice active");
			raidVoiceKeyDown();
	elseif speaking == 1 then
			raidVoiceKeyUp();
	end
end


function VoiceChatDisplayFadeIn()

	if RaidVoiceIsShown == 1 then return; end;
	RaidVoice_display:Show();
	
	local fadeInfo = {};
	fadeInfo.mode = "IN";
	fadeInfo.timeToFade = 0.1;
	UIFrameFade(RaidVoice_display, fadeInfo);

	RaidVoiceIsShown = 1 ;
end

function VoiceChatDisplayFadeOut()

	if RaidVoiceIsShown == 0 then return; end;
	
	RaidVoice_display:Hide();
	UIFrameFadeOut(RaidVoice_display,0.5 );
	
	RaidVoiceIsShown = 0 ;
end


function speakToChannel(text)
	if (raidVoiceCurrentChannel == 0 ) then
	      if (GetRealNumRaidMembers() > 0 or GetRealNumPartyMembers() > 0) then SendAddonMessage( "RAIDVOICE", text, "RAID" );end;
	      return;
	end;
	if (raidVoiceCurrentChannel > 0 and raidVoiceCurrentChannel < 100) then
		SendAddonMessage( "RAIDVOICE", "!CH"..raidVoiceCurrentChannel..";"..text, "GUILD" );
		return;
	end
	if (raidVoiceCurrentChannel == 100 ) then 
		 if (GetNumRaidMembers() > 0 or GetNumPartyMembers() > 0) then SendAddonMessage( "RAIDVOICE", text, "BATTLEGROUND" ); end;
		 return;
	end;
end

function raidVoiceSlashHandler(msg) 
	if msg == "" then
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_SLASHINFO1);
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_SLASHINFO2);
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_SLASHINFO3);
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_SLASHINFO4);
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_SLASHINFO5);
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_SLASHINFO6);
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_SLASHINFO7);

	local key1, key2 = GetBindingKey("VoiceKey");

	if key1 == nil and key2 == nil and (raidVoiceSpecialKeyBinding == nil or raidVoiceSpecialKeyBinding ==0) then
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_WARNING..RAIDVOICE_VOICEKEYNOTBOUND);
	end


		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_SETVOICEKEYINFO);
	end

	if msg == RAIDVOICE_SHOW or msg == RAIDVOICE_ENABLE then
		--VoiceChatDisplayFadeIn();
		raidVoiceHidden = 0;
		raidVoiceOnShow(); 
	end

	if msg == RAIDVOICE_AUTOHIDE then
		--VoiceChatDisplayFadeOut();
		raidVoiceHidden = 1;
		raidVoiceOnShow(); 
	end

	if msg == RAIDVOICE_DISABLE then
		--VoiceChatDisplayFadeOut();
		raidVoiceHidden = 2;
		raidVoiceOnShow();
	end

	if msg == RAIDVOICE_SETTINGS then
		InterfaceOptionsFrame_OpenToCategory(RaidVoice_Settings);
	end

	if msg == RAIDVOICE_PING then
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_PINGING);
		speakToChannel("!PING");
		
	end
	if msg == RAIDVOICE_GPING then
		DEFAULT_CHAT_FRAME:AddMessage(RAIDVOICE_GPINGING);
		SendAddonMessage( "RAIDVOICE", "!GPING", "GUILD" );
			
	end


    if msg == "skin 0" then raidVoiceSkin = 0;end;
	if msg == "skin 1" then raidVoiceSkin = 1;end; 
	if msg == "skin 2" then raidVoiceSkin = 2;end; 
	if msg == "skin 3" then raidVoiceSkin = 3;end; 
	if msg == "skin 4" then raidVoiceSkin = 4;end; 
	if msg == "skin 5" then raidVoiceSkin = 5;end;
	if msg == "skin 6" then raidVoiceSkin = 6;end;
	if msg == "skin 7" then raidVoiceSkin = 7;end;
	if msg == "skin 8" then raidVoiceSkin = 8;end;
	if msg == "skin 9" then raidVoiceSkin = 9;end;
	raidVoiceSetSkin(raidVoiceSkin);

end 

function raidVoiceSettings_OnShow(panel)

        panel.name = "Raid Voice " .. GetAddOnMetadata("RaidVoice","Version");

      local title = panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	title:SetPoint("TOPLEFT", 16, -16);
	title:SetText(RAIDVOICE_ADDONNAME.." "..RAIDVOICE_SETTINGS);

      local titleCurrentVoiceKey = panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	titleCurrentVoiceKey:SetPoint("TOPLEFT", 16, -250);
	titleCurrentVoiceKey:SetText(RAIDVOICE_CURRENT_VOICE_KEY);

	if not textCurrentVoiceKey then
	textCurrentVoiceKey = panel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
	textCurrentVoiceKey:SetWidth(200);
	textCurrentVoiceKey:SetPoint("TOPLEFT", -16, -270);
	end


	textCurrentVoiceKey:SetText(nil);
	
	local key1, key2 = GetBindingKey("VoiceKey") ;

	if ((key1 == nil and key2 == nil) and (raidVoiceSpecialKeyBinding == nil or raidVoiceSpecialKeyBinding ==0))  then
		textCurrentVoiceKey:SetText(RAIDVOICE_VOICEKEYNOTBOUND);
	end
	
	if not (key1 == nil and key2 == nil) then
		if key2 == nil then
			textCurrentVoiceKey:SetText(key1);
		else
			textCurrentVoiceKey:SetText(key1.."\n"..key2);

		end
	end
	


    local titleSpecialKey = panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	titleSpecialKey:SetPoint("TOPRIGHT", -50, -250);
	titleSpecialKey:SetWidth(180);
	titleSpecialKey:SetText(RAIDVOICE_SPECIALKEYBINDING);


local infoKey = panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	infoKey:SetPoint("BOTTOMLEFT", 16, 6);
	infoKey:SetWidth(380);
	infoKey:SetText(RAIDVOICE_SETVOICEKEYINFO);

RaidVoice_Settings_ButtonOption1:SetChecked(raidVoiceLock);
RaidVoice_Settings_ButtonOption2:SetChecked(raidVoiceClamp);

if raidVoiceHidden == 0 then
		RaidVoice_Settings_RadioOption1:SetChecked(true);
		RaidVoice_Settings_RadioOption2:SetChecked(false);
		RaidVoice_Settings_RadioOption3:SetChecked(false);
end
if raidVoiceHidden == 1 then
		RaidVoice_Settings_RadioOption1:SetChecked(false);
		RaidVoice_Settings_RadioOption2:SetChecked(true);
		RaidVoice_Settings_RadioOption3:SetChecked(false);
end
if raidVoiceHidden == 2 then
		RaidVoice_Settings_RadioOption1:SetChecked(false);
		RaidVoice_Settings_RadioOption2:SetChecked(false);
		RaidVoice_Settings_RadioOption3:SetChecked(true);
end

RaidVoice_Settings_ButtonOption3:SetChecked(false);
RaidVoice_Settings_ButtonOption4:SetChecked(false);
RaidVoice_Settings_ButtonOption5:SetChecked(false);

RaidVoice_Settings_ButtonOption6:SetChecked(raidVoiceSync);
RaidVoice_Settings_ButtonOption7:SetChecked(raidVoiceSilencing);
RaidVoice_Settings_ButtonOption8:SetChecked(raidVoiceActivation);
if IsVoiceChatEnabled() then
	--RaidVoice_Settings_ButtonOption8:Enable();
	else
	raidVoiceActivation =0;
	RaidVoice_Settings_ButtonOption8:SetChecked(nil);
	--RaidVoice_Settings_ButtonOption8:Disable();
	RaidVoice_Settings_ButtonOption3:Enable();
	RaidVoice_Settings_ButtonOption4:Enable();
	RaidVoice_Settings_ButtonOption5:Enable();
	
end

if (raidVoiceSpecialKeyBinding == 1 or raidVoiceSpecialKeyBinding == 4 or raidVoiceSpecialKeyBinding == 6 or raidVoiceSpecialKeyBinding == 9)  then  
	RaidVoice_Settings_ButtonOption3:SetChecked(true);
	if textCurrentVoiceKey:GetText() == nil then
	      textCurrentVoiceKey:SetText(RAIDVOICE_SHIFT);
	else
	      textCurrentVoiceKey:SetText(textCurrentVoiceKey:GetText().."\n"..RAIDVOICE_SHIFT);
	end;
end;
if (raidVoiceSpecialKeyBinding == 3 or raidVoiceSpecialKeyBinding == 4 or raidVoiceSpecialKeyBinding == 8 or raidVoiceSpecialKeyBinding == 9)  then  
	RaidVoice_Settings_ButtonOption4:SetChecked(true);
	if textCurrentVoiceKey:GetText() == nil then
	      textCurrentVoiceKey:SetText(RAIDVOICE_CTRL);
	else
	      textCurrentVoiceKey:SetText(textCurrentVoiceKey:GetText().."\n"..RAIDVOICE_CTRL);
	end;
end;
if (raidVoiceSpecialKeyBinding == 5 or raidVoiceSpecialKeyBinding == 6 or raidVoiceSpecialKeyBinding == 8 or raidVoiceSpecialKeyBinding == 9)  then  
	RaidVoice_Settings_ButtonOption5:SetChecked(true);
	if textCurrentVoiceKey:GetText() == nil then
	      textCurrentVoiceKey:SetText(RAIDVOICE_ALT);
	else
	      textCurrentVoiceKey:SetText(textCurrentVoiceKey:GetText().."\n"..RAIDVOICE_ALT);
	end;
end;

RaidVoice_Settings_Slider1:SetValue(raidVoiceSize);

	  raidVoiceSettings_BackUp();
      panel.okay = function (self) raidVoiceSettings_Update(); 	raidVoiceOnShow(); end;
	  panel.cancel = function (self) raidVoiceSettings_Restore(); end;
      panel.default = function (self) raidVoiceSettings_Reset(); RaidVoice_Text:SetWidth(raidVoiceSize -60);raidVoiceSettings_OnShow(panel);end;


	UIDropDownMenu_Initialize(DropDownMenuTest, SettingsMenuInit);
	UIDropDownMenu_SetWidth(DropDownMenuTest, 100);
	UIDropDownMenu_SetButtonWidth(DropDownMenuTest, 124);
	UIDropDownMenu_SetSelectedID(DropDownMenuTest, raidVoiceSkin);
	UIDropDownMenu_JustifyText(DropDownMenuTest, "LEFT");
	

	VoiceChatDisplayFadeIn(); 

end


function raidVoiceSettings_Reset()
	raidVoiceHidden=0;
	raidVoiceLock=0;
	raidVoiceClamp=1;
	raidVoiceSkin = 3;
	raidVoiceSize = 180;
	raidVoiceSpecialKeyBinding = 0;
--	RaidVoice_Text:SetWidth(raidVoiceSize -60);
	raidVoiceChannelsCount = 5;
	raidVoiceChannelsVersion = 0;
	raidVoiceChannels_Reset();
	raidVoiceSync = 1;
	raidVoiceSilencing = 0;
	raidVoiceActivation= 0;
	raidVoiceVersion = GetAddOnMetadata("RaidVoice","Version");
end

function raidVoiceChannels_Reset()

	raidVoiceChannelsCount = 5;
	raidVoiceChannelsVersion = 0;
	RaidVoiceChannels = {
		RAIDVOICE_DEFAULTCHANNEL1,
		RAIDVOICE_DEFAULTCHANNEL2,
		RAIDVOICE_DEFAULTCHANNEL3,
		RAIDVOICE_DEFAULTCHANNEL4,
		RAIDVOICE_DEFAULTCHANNEL5,
	};
	raidVoiceCurrentChannel=0;
end

function raidVoiceSettings_BackUp()
	raidVoiceBHidden = raidVoiceHidden;
	raidVoiceBLock = raidVoiceLock;
	raidVoiceBClamp = raidVoiceClamp;
	raidVoiceBSkin = raidVoiceSkin;
	raidVoiceBSize = raidVoiceSize;
	raidVoiceBSpecialKeyBinding = raidVoiceSpecialKeyBinding;
	raidVoiceBSync  = raidVoiceSync;
	raidVoiceBSilencing =raidVoiceSilencing;
	raidVoiceBActivation =raidVoiceActivation; 

end

function raidVoiceSettings_Restore()
	raidVoiceHidden = raidVoiceBHidden;
	raidVoiceLock = raidVoiceBLock;
	raidVoiceClamp = raidVoiceBClamp;
	raidVoiceSkin = raidVoiceBSkin;
	raidVoiceSize = raidVoiceBSize;
	RaidVoice_Text:SetWidth(raidVoiceSize - 60);
	raidVoiceSpecialKeyBinding = raidVoiceBSpecialKeyBinding;
	raidVoiceSync = raidVoiceBSync;
	raidVoiceSilencing =raidVoiceBSilencing;
	raidVoiceActivation = raidVoiceBActivation; 
	
	if (raidVoiceActivation == 1)then
		--local oldUpdate =RaidVoice_display:GetScript("OnUpdate");
		local newUpdate = function() voiceActivation();  end;
		RaidVoice_display:SetScript("OnUpdate", newUpdate);
		
		else
		
		RaidVoice_display:SetScript("OnUpdate", nil);
	end
 
	raidVoiceSetSkin(raidVoiceSkin);
	if raidVoiceHidden==1 or raidVoiceHidden==2 then
		VoiceChatDisplayFadeOut();
	end;
	RaidVoice_main:SetWidth(raidVoiceSize);  
end



function raidVoiceSettings_Update()


raidVoiceLock  = RaidVoice_Settings_ButtonOption1:GetChecked();
raidVoiceClamp = RaidVoice_Settings_ButtonOption2:GetChecked();
raidVoiceSync  = RaidVoice_Settings_ButtonOption6:GetChecked();
raidVoiceSilencing = RaidVoice_Settings_ButtonOption7:GetChecked();

if IsVoiceChatEnabled() then
	--RaidVoice_Settings_ButtonOption8:Enable();
	raidVoiceActivation =  RaidVoice_Settings_ButtonOption8:GetChecked();
	else
	raidVoiceActivation =0;
	if (RaidVoice_Settings_ButtonOption8:GetChecked() == 1) then message(RAIDVOICE_VOICEACTIVATIONDISABLED);end
		RaidVoice_Settings_ButtonOption8:SetChecked(nil);
	--RaidVoice_Settings_ButtonOption8:Disable();
end

if (raidVoiceActivation == 1) then
	RaidVoice_Settings_ButtonOption5:SetChecked(nil);
	RaidVoice_Settings_ButtonOption4:SetChecked(nil);
	RaidVoice_Settings_ButtonOption3:SetChecked(nil);
	
end

RaidVoice_display:SetClampedToScreen(raidVoiceClamp);
raidVoiceSkin = UIDropDownMenu_GetSelectedID(DropDownMenuTest);

if raidVoiceLock == 1 then       
	RaidVoice_main:EnableMouse(false);
else
	RaidVoice_main:EnableMouse(true);
end


if RaidVoice_Settings_RadioOption1:GetChecked() then
	raidVoiceHidden=0;
	raidVoiceOnShow(); 
end
if RaidVoice_Settings_RadioOption2:GetChecked() then
	raidVoiceHidden=1;
end
if RaidVoice_Settings_RadioOption3:GetChecked() then
	raidVoiceHidden=2;
end



textCurrentVoiceKey:SetText(nil);
local key1, key2 = GetBindingKey("VoiceKey") ;

	if not(key1 == nil and key2 == nil) then
		if key2 == nil then
			textCurrentVoiceKey:SetText(key1);
		else
			textCurrentVoiceKey:SetText(key1.."\n"..key2);

		end
	end
		

raidVoiceSpecialKeyBinding = 0;

if RaidVoice_Settings_ButtonOption3:GetChecked() then  
	raidVoiceSpecialKeyBinding = 1;
	if textCurrentVoiceKey:GetText() == nil then
	      textCurrentVoiceKey:SetText(RAIDVOICE_SHIFT);
	else
	      textCurrentVoiceKey:SetText(textCurrentVoiceKey:GetText().."\n"..RAIDVOICE_SHIFT);
	end;

end;
if RaidVoice_Settings_ButtonOption4:GetChecked() then  	raidVoiceSpecialKeyBinding = raidVoiceSpecialKeyBinding + 3;
		if textCurrentVoiceKey:GetText() == nil then
	      textCurrentVoiceKey:SetText(RAIDVOICE_CTRL);
	else
	      textCurrentVoiceKey:SetText(textCurrentVoiceKey:GetText().."\n"..RAIDVOICE_CTRL);
	end;

end;
if RaidVoice_Settings_ButtonOption5:GetChecked() then   raidVoiceSpecialKeyBinding = raidVoiceSpecialKeyBinding + 5;
	if textCurrentVoiceKey:GetText() == nil then
	      textCurrentVoiceKey:SetText(RAIDVOICE_ALT);
	else
	      textCurrentVoiceKey:SetText(textCurrentVoiceKey:GetText().."\n"..RAIDVOICE_ALT);
	end;
end;

if key1 == nil and key2 == nil and raidVoiceSpecialKeyBinding == 0 then
	textCurrentVoiceKey:SetText(RAIDVOICE_VOICEKEYNOTBOUND);
	end
	
	
	if (raidVoiceActivation == 1)then
		local oldUpdate =RaidVoice_display:GetScript("OnUpdate");
		local newUpdate = function() voiceActivation();  end;
		RaidVoice_display:SetScript("OnUpdate", newUpdate);
		
		else
		
		RaidVoice_display:SetScript("OnUpdate", nil);
	end
	
end



function raidVoiceSetSkin(skin)

if skin == 1 then
	RaidVoice_display:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
      tile = true, tileSize = 16, edgeSize = 16, 
      insets = { left = 5, right = 5, top = 5, bottom = 5 }});
	RaidVoice_display:SetBackdropColor(1,1,1,1);
end

if skin == 2 then

	RaidVoice_display:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
      tile = true, tileSize = 16, edgeSize = 16, 
      insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	RaidVoice_display:SetBackdropColor(0,0,0,1);
end


if skin == 3 then

	RaidVoice_display:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
      tile = true, tileSize = 16, edgeSize = 16, 
      insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	RaidVoice_display:SetBackdropColor(0,0,0,0.7);
end


if skin == 4 then
	RaidVoice_display:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
      tile = true, tileSize = 16, edgeSize = 16, 
      insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	RaidVoice_display:SetBackdropColor(0.1,1,0.1,1);
end


if skin == 5 then
	RaidVoice_display:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
      tile = true, tileSize = 16, edgeSize = 16, 
      insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	RaidVoice_display:SetBackdropColor(1,0,1,1);
end

if skin == 6 then
	RaidVoice_display:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
      tile = true, tileSize = 16, edgeSize = 16, 
      insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	RaidVoice_display:SetBackdropColor(1,0,0,1);
end

if skin == 7 then
	RaidVoice_display:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
      tile = true, tileSize = 16, edgeSize = 16, 
      insets = { left = 4, right = 4, top = 4, bottom = 4}
});
RaidVoice_display:SetBackdropColor(0.6,0.8,0.3,0.8);
end

if skin == 8 then
	RaidVoice_display:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
      tile = true, tileSize = 16, edgeSize = 16, 
      insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	RaidVoice_display:SetBackdropColor(0,0,0,0);
end


if skin == 9 then
	RaidVoice_display:SetBackdrop( { 
  	bgFile = nil, 
  	edgeFile = nil,
	 tile = false, tileSize = 16, edgeSize = 16, 
  	insets = { left = 5, right = 5, top = 5, bottom = 5 }
});
RaidVoice_display:SetBackdropColor(0,0,0,0);
end

end



function SettingsMenuInit(self, level)
   local info = UIDropDownMenu_CreateInfo()
   for k,v in pairs(RaidVoiceSkins) do
      info = UIDropDownMenu_CreateInfo()
      info.text = v
      info.value = v
      info.func = SettingsMenuOnClick
      UIDropDownMenu_AddButton(info, level)
   end

end

function ChannelsMenuInit(self, level)
   local info = UIDropDownMenu_CreateInfo()
   
      info = UIDropDownMenu_CreateInfo();
      info.text = RAIDVOICE_PARTYORRAID;
      info.value = 0;
      info.func = ChannelsMenuOnClick;
      UIDropDownMenu_AddButton(info, level);
      
      info = UIDropDownMenu_CreateInfo();
      info.text = RAIDVOICE_BATTLEGROUND;
      info.value = 100;
      info.func = ChannelsMenuOnClick;
      UIDropDownMenu_AddButton(info, level);
   
   for k,v in pairs(RaidVoiceChannels) do
      info = UIDropDownMenu_CreateInfo();
      info.text = v;
      info.value = k;
      info.func = ChannelsMenuOnClick;
      UIDropDownMenu_AddButton(info, level);
   end

end


 function SettingsMenuOnClick(self)
   UIDropDownMenu_SetSelectedID(DropDownMenuTest, self:GetID())
   raidVoiceSetSkin(UIDropDownMenu_GetSelectedID(DropDownMenuTest));

end

 function ChannelsMenuOnClick(self)
   UIDropDownMenu_SetSelectedID(DropDownChannelSelect, self:GetID())
   raidVoiceCurrentChannel = this.value;

end



function Channels_requestUpdate()
	if (IsInGuild() and raidVoiceSync == 1) then SendAddonMessage( "RAIDVOICE", "!CHANNELS_R;"..raidVoiceChannelsVersion, "GUILD" );
	--DEFAULT_CHAT_FRAME:AddMessage("request"..raidVoiceChannelsVersion);
	end;
end

function Channels_update()

local data;

if (RaidVoiceChannels == nil) then return; end;

if (IsInGuild() and raidVoiceSync == 1 ) then
data=RaidVoiceChannels[1];
if (data == nil) then return; end;

for idx=2, tonumber(raidVoiceChannelsCount) do
 data = data..";".. RaidVoiceChannels[idx];
 end

	 SendAddonMessage( "RAIDVOICE", "!CHANNELS_U;"..raidVoiceChannelsVersion..";"..raidVoiceChannelsCount..";"..data , "GUILD" ); 
	 --DEFAULT_CHAT_FRAME:AddMessage("update sent"..data);
 end;
end


function Channels_applyUpdate(arg2)

	local data;
	local temp; 

temp=string.gsub(arg2, "!CHANNELS_U;(%d*);(.*)", "%1");
data =string.gsub(arg2, "!CHANNELS_U;(%d*);(.*)", "%2");
raidVoiceChannelsVersion= tonumber(temp,10);

 
temp = string.gsub(data, "(%d*);(.*)", "%1");
data = string.gsub(data, "(%d*);(.*)", "%2");
raidVoiceChannelsCount = tonumber(temp,10);


--DEFAULT_CHAT_FRAME:AddMessage("updated");

	for idx=1, tonumber(raidVoiceChannelsCount) do 
		temp = string.gsub(data, "([^;]*);(.*)", "%1");
		data = string.gsub(data, "([^;]*);(.*)", "%2");
		RaidVoiceChannels[idx] = temp;
	 end

	
end;

function raidVoiceRaidChanged()

local name,rank;

raidLeaderName = nil;
	
	for idx=1,GetNumRaidMembers() do
		name,rank = GetRaidRosterInfo(idx);
		if (rank == 2) then
			raidLeaderName = name;
			break;
		end
	end

end

function debugRL()
	raidLeaderName = playerName;
end

-- X-perl integration

function UpdateAllVoiceOnXperl()
	if (XPerl_Voice == nil) then return;end;
	for frame in pairs(XPerl_Voice.frames) do
		UpdateVoiceOnXperl(frame)
	end
end

function UpdateVoiceOnXperl(frame, onoff)
	if (XPerl_Voice == nil) then return;end;
	
		if (onoff == nil) then
			if (frame.partyid and (raidVoiceCurrentChannel==0 or raidVoiceCurrentChannel==100 )) then

				onoff = UnitIsTalking(UnitName(frame.partyid));

				if (IsVoiceChatEnabled() and GetVoiceStatus(frame.partyid) and onoff == false) then
					onoff = UnitIsTalking(frame.partyid);
				end
			end
		end
	

	if (onoff) then
		frame.voiceButton.On:Show()
		frame.voiceButton.Flash:Hide()
		XPerl_FrameFlash(frame.voiceButton.Flash)
	else
		frame.voiceButton.On:Hide()
		XPerl_FrameFlashStop(frame.voiceButton.Flash)
	end

end

function raidVoiceHookVoiceChat()

--SetCVar("EnableVoiceChat", 1);


local origUnitIsTalking = UnitIsTalking;
UnitIsTalking =function(...)
	unit = ... ;
	local text = RaidVoice_Text:GetText();
	if (text== nil or unit == nil) then return origUnitIsTalking(...); end
	
	if not string.find(text, unit) then
		 return origUnitIsTalking(...);
	end
	
	return 1;
	end

end;



